*FILENAME: div_analysis_dfl.do
***dataset needs to be in memory
***creates new var dfl
***$dflorigwgt = original weight (should be set to a var 
*** equal to 1 if no original weight)
***$dflbyvar = var denoting the groups being reweighted
***$dflbyvarbasegroup = the value of $dflbyvar that all 
*** $dflbyvar groups are supposed to be reweighted to resemble
***$dflvarlist = list of all vars that the the $dflbyvar
*** groups are being reweighted on
***$dflbalanceacrossbyvar = flag indicating that one wants the
*** each value of $dflbyvar to carry equal weight, rather than
*** to reflect the original distribution of $dflorigwgt across
*** values of $dflbyvar (e.g. if $dflbyvar=year, then 
*** $dflbalanceacrossbyvar=1 implies that you want the final 
*** regression to weight each year equally no matter what the
*** distribution of $dflorigwgt across years is)


capture drop _merge dfl zz*
sort $dflvarlist $dflbyvar
save tempdfl, replace
collapse (sum) $dflorigwgt, by($dflvarlist $dflbyvar)
save tempdfl2, replace
keep if $dflbyvar==$dflbyvarbasegroup
rename $dflorigwgt zzbasegroupval
sort $dflvarlist
save tempdfl3, replace
use tempdfl2, clear
sort $dflvarlist
merge $dflvarlist using tempdfl3
drop _merge
gen zzfactor = zzbasegroupval/$dflorigwgt
if $dflbalanceacrossbyvar!=1 {
	bys $dflbyvar: egen zzdflbyvarsum = sum($dflorigwgt)
	quietly sum $dflorigwgt if $dflbyvar==$dflbyvarbasegroup
	replace zzfactor = zzfactor*(zzdflbyvarsum/r(sum))
}
replace zzfactor=0 if zzfactor==.
drop $dflorigwgt
sort $dflvarlist $dflbyvar
merge $dflvarlist $dflbyvar using tempdfl
gen dfl = zzfactor*$dflorigwgt
drop zz* _merge

