*FILENAME: div_analysis_dfldefinebins.do
***requires $divdflvar1 to be a category var
***use $divdflvar2 (a continuous var) to create 
*** dflbin, which becomes the second dfl var
***requires $divdflnumbins (=4 if quartiles)
***it bins all obs into $divdflnumbins within
*** each value of of $divdflvar1, according to
*** the quantiles of the distribution of 
*** $divdflvar2 within only the main dfl group
*** ($dflbyvar==$dflbyvarbasegroup)


capture drop zz* 
capture drop dflbin 
capture drop _merge 
capture drop tempdflorigwgt
egen zzgroup = group($divdflvar1)
quietly sum zzgroup
global groupmax=r(max)
gen dflbin=.
forvalues g=1/$groupmax {
	pctile zzdflcutpoints = $divdflvar2 if $dflbyvar==$dflbyvarbasegroup & zzgroup==`g', n($divdflnumbins)
	xtile dflbintemp = $divdflvar2, c(zzdflcutpoints)
	replace dflbin=dflbintemp if zzgroup==`g'
	drop dflbintemp zzdflcutpoints
}
drop zz*
global dflvarlist = "$divdflvar1 dflbin"
gen tempdflorigwgt = $dflorigwgt
global dflorigwgt = "tempdflorigwgt"

