*FILENAME: div_analysis_graph.do;


*for each year make resids plus dd coeff and add back constant to match overall mean;
use temp_yvarscaled, clear
quietly sum tax_year if yvarscaled!=.
global tymin=r(min)
global tymax=r(max)
global obs = $tymax-$tymin+1
gen resid=.
save temp, replace
forvalues ty=$tymin/$tymax {
	use temp, clear
	global ty = `ty'
	reg yvarscaled $controls ddccorp [w=$wgt] if $ty==tax_year
	drop if e(sample)!=1 & $ty==tax_year
	predict tempresid, r
	replace tempresid = tempresid + _b[ddccorp]*ddccorp
	quietly sum yvarscaled [w=$wgt] if $ty==tax_year
	global origmean=r(mean)
	quietly sum tempresid [w=$wgt] if $ty==tax_year
	replace tempresid = tempresid + ($origmean-r(mean)) if $ty==tax_year
	replace resid = tempresid if $ty==tax_year
	drop tempresid
	save temp, replace
}

*detrend if necessary, adding back pre-mean;
if $detrend==1 {
  quietly sum $byvar
  global byvarmin=r(min)
  global byvarmax=r(max)
  forvalues byvar=$byvarmin/$byvarmax {
	reg resid tax_year [w=$wgt] if $byvar==`byvar' & tax_year<=2002
	predict tempresid, r
    quietly sum resid if tax_year<=2002 & $byvar==`byvar' [w=$wgt]
    global premean=r(mean)
    quietly sum tempresid if tax_year<=2002 & $byvar==`byvar' [w=$wgt]
    replace resid = tempresid + ($premean-r(mean)) if $byvar==`byvar'
	drop tempresid
  }	
}
capture drop zz*

*collapse and save graph data;
capture collapse (mean) resid (count) freq=resid [w=$wgt], by($byvar tax_year)
rename $byvar byvar
save tempgraphdata, replace

