*FILENAME: div_analysis_makeyvarscaled.do;


*load data
if $doyrbyyr==0 {
  if $cutvarnewdfl==1 {
    use tinc tax_year one nc2dig revlag2to1 $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
  else if $dosizehetero==1 {
    use tinc tax_year one cutvarbin $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
  else {
    use tinc tax_year one $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
}
else {
  if $cutvarnewdfl==1 {
    use tinc tax_year one nc2dig revlag2to1 $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
  else if $dosizehetero==1 {
    use tinc tax_year one cutvarbin $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
  else {
    use tinc tax_year one $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
  }
}

*create untrimmed unnormalized annual yvarscaled;
gen yvarscaled = $yvar/$basevar
drop if yvarscaled==.
capture drop zz*

*if necessary, create cutvar ddvars and create new dfl weight;
if "$cutvar"!="" & $dosizehetero==0 {
	pctile zzcutpoints = $cutvar if yvarscaled!=. & $byvar==1, n(5)
	xtile ddcutvar = $cutvar, c(zzcutpoints)		
	replace ddcutvar=. if ddcutvar!=1 & ddcutvar!=5
	replace ddcutvar=0 if ddcutvar==1
	replace ddcutvar=1 if ddcutvar==5
	foreach ddvar in $ddvars {
		gen `ddvar'_cutvar = `ddvar'*ddcutvar
		global ddvars = "$ddvars `ddvar'_cutvar"
	}
	global ddvars = "ddcutvar $ddvars"
	capture drop zz*
	if $cutvarnewdfl==1 {
		global byvar = "ddccorp_byvar"
		global divdflvar1 = "nc2dig"
		global dflbyvar = "taxyearddccorpcutvar"
		global dflbyvarbasegroup = 200211
		global divdflnumbins = 10
		global dflbalanceacrossbyvar = 0
		global divdflvar2 = "revlag2to1"
		gen taxyearddccorpcutvar = tax_year*100+ddccorp*10+ddcutvar
		global dflorigwgt = "$divdflvar2"
		*do dfl only by nc2dig if cutvar=size
		if "$cutvar"=="$divdflvar2" {
			global divdflvar2 = "one"
		}
		do ${dirdo}/div_analysis_dfldefinebins
		do ${dirdo}/div_analysis_dfl
		rename dfl dfltemp
		global wgt = "dfltemp"
	}
	capture drop zz*
}

*winsorize;
if "$trimqtop"!="" | "$trimqbot"!=""  {
	egen zzgroup = group($byvar ddpost)
	quietly sum zzgroup
	global zzgroupmax = r(max)
	forvalues group=1/$zzgroupmax {
		sum yvarscaled [w=$wgt] if zzgroup==`group', detail
		if "$trimqtop"!="" {
			replace yvarscaled=r($trimqtop) if yvarscaled>r($trimqtop) & yvarscaled!=. & zzgroup==`group'
		}
		if "$trimqbot"!="" {
			replace yvarscaled=r($trimqbot) if yvarscaled<r($trimqbot) & yvarscaled!=. & zzgroup==`group'
		}
	}
}
capture drop zz*

*normalize;
gen yvarscaled_nonorm = yvarscaled
if $norm==1 {
	egen zzgroup = group($byvar)
	quietly sum zzgroup
	global zzgroupmax = r(max)
	forvalues group=1/$zzgroupmax {
		sum yvarscaled [w=$wgt] if zzgroup==`group' & tax_year<=2002
		replace yvarscaled = yvarscaled/r(mean) if zzgroup==`group'
	}
}
capture drop zz*

*restrict to <=2004 if necessary
if $dothrough2004only==1 {
	keep if tax_year<2004.5
}

save temp_yvarscaled, replace

