*FILENAME: div_analysis_makeyvarscaled_graph.do;


*load data
if $doyrbyyr==0 {
	if $cutvarnewdfl==1 {
		use tinc tax_year one nc2dig revlag2to1 $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
	else if $dosizehetero==1 {
		use tinc tax_year one cutvarbin $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
	else {
		use tinc tax_year one $byvar $yvar $basevar $controls $wgt $clustervar $cutvar ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
}
else {
	if $cutvarnewdfl==1 {
		use tinc tax_year one nc2dig revlag2to1 $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
	else if $dosizehetero==1 {
		use tinc tax_year one cutvarbin $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
	else {
		use tinc tax_year one $byvar $yvar $basevar $controls $wgt $clustervar $cutvar $ddvarsyrbyyr ddccorp ddpost ddtaxyear ddposttaxyear ddccorppost ddccorptaxyear ddccorptaxyearpost using $dirdta/$data, clear
	}
}

*create untrimmed unnormalized annual yvarscaled;
gen yvarscaled = $yvar/$basevar
drop if yvarscaled==.
capture drop zz*

*winsorize;
if "$trimqtop"!="" | "$trimqbot"!=""  {
	egen zzgroup = group($byvar)
	quietly sum zzgroup
	global zzgroupmax = r(max)
	forvalues group=1/$zzgroupmax {
		sum yvarscaled [w=$wgt] if zzgroup==`group' & tax_year<=2002, detail
		if "$trimqtop"!="" {
			replace yvarscaled=r($trimqtop) if yvarscaled>r($trimqtop) & yvarscaled!=. & zzgroup==`group'
		}
		if "$trimqbot"!="" {
			replace yvarscaled=r($trimqbot) if yvarscaled<r($trimqbot) & yvarscaled!=. & zzgroup==`group'
		}
	}
}
capture drop zz*

*normalize;
gen yvarscaled_nonorm = yvarscaled
if $norm==1 {
	forvalues byvar=0/1 {
		sum yvarscaled [w=$wgt] if $byvar==`byvar' & tax_year<=2002
		global byvar`byvar'premean_nonorm = r(mean)
		replace yvarscaled = yvarscaled/r(mean) if $byvar==`byvar'
	}
}
capture drop zz*
save temp_yvarscaled, replace

